many_args:
        // global(%rip) is the address of global; to make it easier for
        // the linker to put the program at any address, it is encoded
        // relative to the instruction pointer.
	movq	%rdi, global(%rip)    // global[0] = a
	movq	%rsi, global+8(%rip)  // global[1] = b
	movq	%rdx, global+16(%rip) // global[2] = c
	movq	%rcx, global+24(%rip) // global[3] = d
	movq	%r8, global+32(%rip)  // global[4] = e
	movq	%r9, global+40(%rip)  // global[5] = f
        // No memory-to-memory move, so set global[6] and [7] in two steps.
	movq	8(%rsp), %rax         // tmp = g
	movq	%rax, global+48(%rip) // global[6] = tmp
	movq	16(%rsp), %rax        // tmp = h
	movq	%rax, global+56(%rip) // global[7] = tmp
	ret

.LC0:
	.string	"global[7] = %ld"

main:
	// many_args(10, 20, 30, 40, 50, 60, 70, 80);
	subq	$24, %rsp    // make room for g and h on the stack
	movq	$80, 8(%rsp) // h
	movq	$70, (%rsp)  // g
	movl	$60, %r9d    // f - 32-bit move clears the top 32 bits.
	movl	$50, %r8d    // e
	movl	$40, %ecx    // d
	movl	$30, %edx    // c
	movl	$20, %esi    // b
	movl	$10, %edi    // a
	call	many_args

	// printf("global[7] = %ld", global[7]);
	movq	global+56(%rip), %rdx
	movl	$.LC0, %esi
	movl	$1, %edi
	movl	$0, %eax
	call	__printf_chk

        // return 0
	movl	$0, %eax

        // must restore the stack
	addq	$24, %rsp
	ret

        // global is 64 bytes and should be aligned to a multiple of 32.
	.comm	global,64,32
